Index: squid/src/client_side.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/client_side.c,v
retrieving revision 1.202.2.6
retrieving revision 1.202.2.7
diff -u -r1.202.2.6 -r1.202.2.7
--- squid/src/client_side.c	29 Sep 2007 10:38:27 -0000	1.202.2.6
+++ squid/src/client_side.c	27 Nov 2007 08:12:25 -0000	1.202.2.7
@@ -1,6 +1,6 @@
 
 /*
- * $Id: client_side.c,v 1.202.2.6 2007/09/29 10:38:27 adri Exp $
+ * $Id: client_side.c,v 1.202.2.7 2007/11/27 08:12:25 adri Exp $
  *
  * DEBUG: section 33    Client-side Routines
  * AUTHOR: Duane Wessels
@@ -116,14 +116,14 @@
 static int clientGotNotEnough(clientHttpRequest *);
 static void checkFailureRatio(err_type, hier_code);
 static void clientProcessMiss(clientHttpRequest *);
+static void clientProcessHit(clientHttpRequest * http);
 static void clientBuildReplyHeader(clientHttpRequest * http, HttpReply * rep);
 static clientHttpRequest *parseHttpRequestAbort(ConnStateData * conn, const char *uri);
 static clientHttpRequest *parseHttpRequest(ConnStateData *, HttpMsgBuf *, method_t *, int *);
-static void clientRedirectStart(clientHttpRequest * http);
-static RH clientRedirectDone;
+
 static void clientCheckNoCache(clientHttpRequest *);
 static void clientCheckNoCacheDone(int answer, void *data);
-static STNCB clientHandleIMSReply;
+static STHCB clientHandleIMSReply;
 static int clientGetsOldEntry(StoreEntry * new, StoreEntry * old, request_t * request);
 #if USE_IDENT
 static IDCB clientIdentDone;
@@ -135,14 +135,15 @@
 #endif /* FOLLOW_X_FORWARDED_FOR */
 static int clientOnlyIfCached(clientHttpRequest * http);
 static STNCB clientSendMoreData;
-static STNCB clientSendMoreHeaderData;
-static STNCB clientCacheHit;
+static STHCB clientSendHeaders;
+static STHCB clientCacheHit;
 static void clientSetKeepaliveFlag(clientHttpRequest *);
 static void clientPackRangeHdr(const HttpReply * rep, const HttpHdrRangeSpec * spec, String boundary, MemBuf * mb);
 static void clientPackTermBound(String boundary, MemBuf * mb);
-static void clientInterpretRequestHeaders(clientHttpRequest *);
 static void clientProcessRequest(clientHttpRequest *);
-static void clientProcessExpired(void *data);
+static void clientProcessExpired(clientHttpRequest *);
+static void clientRefreshCheck(clientHttpRequest *);
+static REFRESHCHECK clientRefreshCheckDone;
 static void clientProcessOnlyIfCachedMiss(clientHttpRequest * http);
 static int clientCachable(clientHttpRequest * http);
 static int clientHierarchical(clientHttpRequest * http);
@@ -155,7 +156,6 @@
 static void clientEatRequestBody(clientHttpRequest *);
 static void clientAccessCheck(void *data);
 static void clientAccessCheckDone(int answer, void *data);
-static void clientAccessCheck2(void *data);
 static void clientAccessCheckDone2(int answer, void *data);
 static BODY_HANDLER clientReadBody;
 static void clientAbortBody(request_t * req);
@@ -167,6 +167,31 @@
 static StoreEntry *clientCreateStoreEntry(clientHttpRequest *, method_t, request_flags);
 static inline int clientNatLookup(ConnStateData * conn);
 
+/* Temporary here while restructuring stuff */
+static void
+storeClientCopyHeadersCB(void *data, char *buf, ssize_t size)
+{
+    clientHttpRequest *http = data;
+    assert(http->header_callback);
+    assert(http->header_entry);
+    memFree(buf, MEM_STORE_CLIENT_BUF);
+    if (!http->header_entry)
+	return;
+    if (size < 0 || !memHaveHeaders(http->header_entry->mem_obj)) {
+	http->header_callback(data, NULL);
+	return;
+    }
+    http->header_callback(data, http->header_entry->mem_obj->reply);
+}
+void
+storeClientCopyHeaders(store_client * sc, StoreEntry * e, STHCB * callback, void *callback_data)
+{
+    clientHttpRequest *http = callback_data;
+    http->header_callback = callback;
+    http->header_entry = e;
+    storeClientCopy(http->sc, e, 0, 0, STORE_CLIENT_BUF_SZ, memAllocate(MEM_STORE_CLIENT_BUF), storeClientCopyHeadersCB, http);
+}
+
 #if USE_IDENT
 static void
 clientIdentDone(const char *ident, void *data)
@@ -177,7 +202,7 @@
 
 #endif
 
-static aclCheck_t *
+aclCheck_t *
 clientAclChecklistCreate(const acl_access * acl, const clientHttpRequest * http)
 {
     aclCheck_t *ch;
@@ -358,7 +383,7 @@
     aclNBCheck(http->acl_checklist, clientAccessCheckDone, http);
 }
 
-static void
+void
 clientAccessCheck2(void *data)
 {
     clientHttpRequest *http = data;
@@ -394,12 +419,14 @@
     if (h->request == NULL)
 	h->request = requestLink(requestCreate(m, PROTO_NONE, null_string));
     e = storeCreateEntry(h->uri, flags, m);
+    if (h->request->store_url)
+	storeEntrySetStoreUrl(e, h->request->store_url);
     h->sc = storeClientRegister(e, h);
 #if DELAY_POOLS
     if (h->log_type != LOG_TCP_DENIED)
 	delaySetStoreClient(h->sc, delayClient(h));
 #endif
-    storeClientRef(h->sc, e, 0, 0, SM_PAGE_SIZE, clientSendMoreHeaderData, h);
+    storeClientCopyHeaders(h->sc, e, clientSendHeaders, h);
     return e;
 }
 
@@ -531,123 +558,6 @@
 }
 
 static void
-clientRedirectAccessCheckDone(int answer, void *data)
-{
-    clientHttpRequest *http = data;
-    http->acl_checklist = NULL;
-    if (answer == ACCESS_ALLOWED)
-	redirectStart(http, clientRedirectDone, http);
-    else
-	clientRedirectDone(http, NULL);
-}
-
-static void
-clientRedirectStart(clientHttpRequest * http)
-{
-    debug(33, 5) ("clientRedirectStart: '%s'\n", http->uri);
-    if (Config.Program.url_rewrite.command == NULL) {
-	clientRedirectDone(http, NULL);
-	return;
-    }
-    if (Config.accessList.url_rewrite) {
-	http->acl_checklist = clientAclChecklistCreate(Config.accessList.url_rewrite, http);
-	aclNBCheck(http->acl_checklist, clientRedirectAccessCheckDone, http);
-    } else {
-	redirectStart(http, clientRedirectDone, http);
-    }
-}
-
-static void
-clientRedirectDone(void *data, char *result)
-{
-    clientHttpRequest *http = data;
-    request_t *new_request = NULL;
-    request_t *old_request = http->request;
-    const char *urlgroup = http->conn->port->urlgroup;
-    debug(33, 5) ("clientRedirectDone: '%s' result=%s\n", http->uri,
-	result ? result : "NULL");
-    assert(http->redirect_state == REDIRECT_PENDING);
-    http->redirect_state = REDIRECT_DONE;
-    if (result) {
-	http_status status;
-	if (*result == '!') {
-	    char *t;
-	    if ((t = strchr(result + 1, '!')) != NULL) {
-		urlgroup = result + 1;
-		*t++ = '\0';
-		result = t;
-	    } else {
-		debug(33, 1) ("clientRedirectDone: bad input: %s\n", result);
-	    }
-	}
-	status = (http_status) atoi(result);
-	if (status == HTTP_MOVED_PERMANENTLY
-	    || status == HTTP_MOVED_TEMPORARILY
-	    || status == HTTP_SEE_OTHER
-	    || status == HTTP_TEMPORARY_REDIRECT) {
-	    char *t = result;
-	    if ((t = strchr(result, ':')) != NULL) {
-		http->redirect.status = status;
-		http->redirect.location = xstrdup(t + 1);
-		goto redirect_parsed;
-	    } else {
-		debug(33, 1) ("clientRedirectDone: bad input: %s\n", result);
-	    }
-	} else if (strcmp(result, http->uri))
-	    new_request = urlParse(old_request->method, result);
-    }
-  redirect_parsed:
-    if (new_request) {
-	safe_free(http->uri);
-	http->uri = xstrdup(urlCanonical(new_request));
-	new_request->http_ver = old_request->http_ver;
-	httpHeaderAppend(&new_request->header, &old_request->header);
-	new_request->client_addr = old_request->client_addr;
-	new_request->client_port = old_request->client_port;
-#if FOLLOW_X_FORWARDED_FOR
-	new_request->indirect_client_addr = old_request->indirect_client_addr;
-#endif /* FOLLOW_X_FORWARDED_FOR */
-	new_request->my_addr = old_request->my_addr;
-	new_request->my_port = old_request->my_port;
-	new_request->flags = old_request->flags;
-	new_request->flags.redirected = 1;
-	if (old_request->auth_user_request) {
-	    new_request->auth_user_request = old_request->auth_user_request;
-	    authenticateAuthUserRequestLock(new_request->auth_user_request);
-	}
-	if (old_request->body_reader) {
-	    new_request->body_reader = old_request->body_reader;
-	    new_request->body_reader_data = old_request->body_reader_data;
-	    old_request->body_reader = NULL;
-	    old_request->body_reader_data = NULL;
-	}
-	new_request->content_length = old_request->content_length;
-	if (strBuf(old_request->extacl_log))
-	    new_request->extacl_log = stringDup(&old_request->extacl_log);
-	if (old_request->extacl_user)
-	    new_request->extacl_user = xstrdup(old_request->extacl_user);
-	if (old_request->extacl_passwd)
-	    new_request->extacl_passwd = xstrdup(old_request->extacl_passwd);
-	requestUnlink(old_request);
-	http->request = requestLink(new_request);
-    } else {
-	/* Don't mess with urlgroup on internal request */
-	if (old_request->flags.internal)
-	    urlgroup = NULL;
-    }
-    safe_free(http->request->urlgroup);		/* only paranoia. should not happen */
-    if (urlgroup && *urlgroup)
-	http->request->urlgroup = xstrdup(urlgroup);
-    clientInterpretRequestHeaders(http);
-#if HEADERS_LOG
-    headersLog(0, 1, request->method, request);
-#endif
-    /* XXX This really should become a ref-counted string type pointer, not a copy! */
-    fd_note(http->conn->fd, http->uri);
-    clientAccessCheck2(http);
-}
-
-static void
 clientCheckNoCache(clientHttpRequest * http)
 {
     if (Config.accessList.noCache && http->request->flags.cachable) {
@@ -689,74 +599,49 @@
 }
 
 static void
-clientHandleETagReply(void *data, mem_node_ref ref, ssize_t size)
+clientHandleETagReply(void *data, HttpReply * rep)
 {
     //const char *buf = ref.node->data + ref.offset;
     clientHttpRequest *http = data;
     StoreEntry *entry = http->entry;
-    MemObject *mem;
-    const char *url = storeUrl(entry);
-    http_status status;
-    debug(33, 3) ("clientHandleETagReply: %s, %d bytes\n", url, (int) size);
+    const char *url = storeLookupUrl(entry);
     if (entry == NULL) {
 	/* client aborted */
-        stmemNodeUnref(&ref);
 	return;
     }
-    if (size < 0 && !EBIT_TEST(entry->flags, ENTRY_ABORTED)) {
-        stmemNodeUnref(&ref);
+    if (!rep) {
+	debug(33, 3) ("clientHandleETagReply: FAILED '%s'\n", url);
 	clientHandleETagMiss(http);
 	return;
     }
-    mem = entry->mem_obj;
-    status = mem->reply->sline.status;
     if (EBIT_TEST(entry->flags, ENTRY_ABORTED)) {
 	debug(33, 3) ("clientHandleETagReply: ABORTED '%s'\n", url);
-        stmemNodeUnref(&ref);
 	clientHandleETagMiss(http);
 	return;
     }
-    if (STORE_PENDING == entry->store_status && 0 == status) {
-	debug(33, 3) ("clientHandleETagReply: Incomplete headers for '%s'\n", url);
-	if (size >= SM_PAGE_SIZE) {
-	    /* will not get any bigger than that */
-	    debug(33, 3) ("clientHandleETagReply: Reply is too large '%s'\n", url);
-            stmemNodeUnref(&ref);
-	    clientHandleETagMiss(http);
-	} else {
-            stmemNodeUnref(&ref);
-	    storeClientRef(http->sc, entry,
-		http->out.offset + size,
-		http->out.offset,
-		SM_PAGE_SIZE,
-		clientHandleETagReply,
-		http);
-	}
-	return;
-    }
-    if (HTTP_NOT_MODIFIED == mem->reply->sline.status) {
+    debug(33, 3) ("clientHandleETagReply: %s = %d\n", url, (int) rep->sline.status);
+    if (HTTP_NOT_MODIFIED == rep->sline.status) {
 	/* Remember the ETag and restart */
-        stmemNodeUnref(&ref);
-	if (mem->reply) {
+	if (rep) {
 	    request_t *request = http->request;
-	    const char *etag = httpHeaderGetStr(&mem->reply->header, HDR_ETAG);
+	    const char *etag = httpHeaderGetStr(&rep->header, HDR_ETAG);
 	    const char *vary = request->vary_headers;
-	    int has_vary = httpHeaderHas(&entry->mem_obj->reply->header, HDR_VARY);
+	    int has_vary = httpHeaderHas(&rep->header, HDR_VARY);
 #if X_ACCELERATOR_VARY
-	    has_vary |= httpHeaderHas(&entry->mem_obj->reply->header, HDR_X_ACCELERATOR_VARY);
+	    has_vary |= httpHeaderHas(&rep->header, HDR_X_ACCELERATOR_VARY);
 #endif
 	    if (has_vary)
-		vary = httpMakeVaryMark(request, mem->reply);
+		vary = httpMakeVaryMark(request, rep);
 
 	    if (etag && vary) {
-		storeAddVary(mem->url, mem->method, NULL, httpHeaderGetStr(&mem->reply->header, HDR_ETAG), request->vary_hdr, request->vary_headers, strBuf(request->vary_encoding));
+		storeAddVary(url, entry->mem_obj->method, NULL, httpHeaderGetStr(&rep->header, HDR_ETAG), request->vary_hdr, request->vary_headers, strBuf(request->vary_encoding));
 	    }
 	}
 	clientHandleETagMiss(http);
 	return;
     }
     /* Send the new object to the client */
-    clientSendMoreHeaderData(data, ref, size);
+    clientSendHeaders(data, rep);
     return;
 }
 
@@ -767,6 +652,8 @@
     StoreEntry *entry = NULL;
     debug(33, 3) ("clientProcessETag: '%s'\n", http->uri);
     entry = storeCreateEntry(url, http->request->flags, http->request->method);
+    if (http->request->store_url)
+	storeEntrySetStoreUrl(entry, http->request->store_url);
     http->sc = storeClientRegister(entry, http);
 #if DELAY_POOLS
     /* delay_id is already set on original store client */
@@ -778,18 +665,34 @@
     /* Register with storage manager to receive updates when data comes in. */
     if (EBIT_TEST(entry->flags, ENTRY_ABORTED))
 	debug(33, 0) ("clientProcessETag: found ENTRY_ABORTED object\n");
-    storeClientRef(http->sc, entry,
-	http->out.offset,
-	http->out.offset,
-	SM_PAGE_SIZE,
+    storeClientCopyHeaders(http->sc, entry,
 	clientHandleETagReply,
 	http);
 }
 
 static void
-clientProcessExpired(void *data)
+clientRefreshCheck(clientHttpRequest * http)
+{
+    refreshCheckSubmit(http->entry, clientRefreshCheckDone, http);
+}
+
+static void
+clientRefreshCheckDone(void *data, int fresh, const char *log)
 {
     clientHttpRequest *http = data;
+    if (log) {
+	safe_free(http->al.ext_refresh);
+	http->al.ext_refresh = xstrdup(log);
+    }
+    if (fresh)
+	clientProcessHit(http);
+    else
+	clientProcessExpired(http);
+}
+
+static void
+clientProcessExpired(clientHttpRequest * http)
+{
     char *url = http->uri;
     StoreEntry *entry = NULL;
     int hit = 0;
@@ -828,6 +731,8 @@
     }
     if (!entry) {
 	entry = storeCreateEntry(url, http->request->flags, http->request->method);
+	if (http->request->store_url)
+	    storeEntrySetStoreUrl(entry, http->request->store_url);
 	if (http->entry->mem_obj) {
 	    http->entry->mem_obj->refresh_timestamp = squid_curtime;
 	    if (Config.onoff.collapsed_forwarding) {
@@ -836,7 +741,12 @@
 	    }
 	}
     }
-    /* NOTE, don't call storeLockObject(), storeCreateEntry() does it */
+    if (entry->mem_obj->old_entry) {
+	storeUnlockObject(entry->mem_obj->old_entry);
+	entry->mem_obj->old_entry = NULL;
+    }
+    entry->mem_obj->old_entry = http->old_entry;
+    storeLockObject(entry->mem_obj->old_entry);
     http->sc = storeClientRegister(entry, http);
 #if DELAY_POOLS
     /* delay_id is already set on original store client */
@@ -848,6 +758,7 @@
     } else
 	http->request->lastmod = -1;
     debug(33, 5) ("clientProcessExpired: lastmod %ld\n", (long int) entry->lastmod);
+    /* NOTE, don't call storeLockObject(), storeCreateEntry() does it */
     http->entry = entry;
     http->out.offset = 0;
     if (can_revalidate) {
@@ -862,10 +773,7 @@
     /* Register with storage manager to receive updates when data comes in. */
     if (EBIT_TEST(entry->flags, ENTRY_ABORTED))
 	debug(33, 0) ("clientProcessExpired: found ENTRY_ABORTED object\n");
-    storeClientRef(http->sc, entry,
-	http->out.offset,
-	http->out.offset,
-	SM_PAGE_SIZE,
+    storeClientCopyHeaders(http->sc, entry,
 	clientHandleIMSReply,
 	http);
 }
@@ -881,8 +789,16 @@
     /* If the reply is a failure then send the old object as a last
      * resort */
     if (status >= 500 && status < 600) {
-	debug(33, 3) ("clientGetsOldEntry: YES, failure reply=%d\n", status);
-	return 1;
+	if (EBIT_TEST(new_entry->flags, ENTRY_NEGCACHED)) {
+	    debug(33, 3) ("clientGetsOldEntry: NO, negatively cached failure reply=%d\n", status);
+	    return 0;
+	}
+	if (refreshCheckStaleOK(old_entry, request)) {
+	    debug(33, 3) ("clientGetsOldEntry: YES, failure reply=%d and old acceptable to send\n", status);
+	    return 1;
+	}
+	debug(33, 3) ("clientGetsOldEntry: NO, failure reply=%d and old NOT acceptable to send\n", status);
+	return 0;
     }
     /* If the reply is not to a cache validation conditional then
      * we should forward it to the client */
@@ -929,7 +845,7 @@
 
 
 static void
-clientHandleIMSReply(void *data, mem_node_ref ref, ssize_t size)
+clientHandleIMSReply(void *data, HttpReply * rep)
 {
     clientHttpRequest *http = data;
     StoreEntry *entry = http->entry;
@@ -938,23 +854,20 @@
     int unlink_request = 0;
     StoreEntry *oldentry;
     int recopy = 1;
-    http_status status;
-    debug(33, 3) ("clientHandleIMSReply: %s, %ld bytes\n", url, (long int) size);
+    debug(33, 3) ("clientHandleIMSReply: %s\n", url);
     if (http->old_entry && http->old_entry->mem_obj && http->old_entry->mem_obj->ims_entry) {
 	storeUnlockObject(http->old_entry->mem_obj->ims_entry);
 	http->old_entry->mem_obj->ims_entry = NULL;
     }
     if (entry == NULL) {
-        stmemNodeUnref(&ref);
 	return;
     }
-    if (size < 0 && !EBIT_TEST(entry->flags, ENTRY_ABORTED)) {
-        stmemNodeUnref(&ref);
-	return;
+    if (entry->mem_obj->old_entry) {
+	storeUnlockObject(entry->mem_obj->old_entry);
+	entry->mem_obj->old_entry = NULL;
     }
     mem = entry->mem_obj;
-    status = mem->reply->sline.status;
-    if (EBIT_TEST(entry->flags, ENTRY_ABORTED)) {
+    if (!rep) {
 	debug(33, 3) ("clientHandleIMSReply: ABORTED '%s'\n", url);
 	/* We have an existing entry, but failed to validate it */
 	/* Its okay to send the old one anyway */
@@ -963,45 +876,26 @@
 	storeUnlockObject(entry);
 	entry = http->entry = http->old_entry;
 	http->sc = http->old_sc;
-    } else if (STORE_PENDING == entry->store_status && 0 == status) {
-	debug(33, 3) ("clientHandleIMSReply: Incomplete headers for '%s'\n", url);
-	if (size >= SM_PAGE_SIZE) {
-	    /* will not get any bigger than that */
-	    debug(33, 3) ("clientHandleIMSReply: Reply is too large '%s', using old entry\n", url);
-	    /* use old entry, this repeats the code abovez */
-	    http->log_type = LOG_TCP_REFRESH_FAIL_HIT;
-	    storeClientUnregister(http->sc, entry, http);
-	    storeUnlockObject(entry);
-	    entry = http->entry = http->old_entry;
-	    http->sc = http->old_sc;
-	    /* continue */
-	} else {
-            stmemNodeUnref(&ref);
-	    storeClientRef(http->sc, entry,
-		http->out.offset + size,
-		http->out.offset,
-		SM_PAGE_SIZE,
-		clientHandleIMSReply,
-		http);
-	    return;
-	}
     } else if (clientGetsOldEntry(entry, http->old_entry, http->request)) {
 	/* We initiated the IMS request, the client is not expecting
 	 * 304, so put the good one back.  First, make sure the old entry
 	 * headers have been loaded from disk. */
 	oldentry = http->old_entry;
-	http->log_type = LOG_TCP_REFRESH_HIT;
 	if (oldentry->mem_obj->request == NULL) {
 	    oldentry->mem_obj->request = requestLink(mem->request);
 	    unlink_request = 1;
 	}
-	if (mem->reply->sline.status == HTTP_NOT_MODIFIED) {
+	if (rep->sline.status == HTTP_NOT_MODIFIED) {
 	    /* Don't memcpy() the whole reply structure here.  For example,
 	     * www.thegist.com (Netscape/1.13) returns a content-length for
 	     * 304's which seems to be the length of the 304 HEADERS!!! and
 	     * not the body they refer to.  */
-	    httpReplyUpdateOnNotModified(oldentry->mem_obj->reply, mem->reply);
+	    httpReplyUpdateOnNotModified(oldentry->mem_obj->reply, rep);
 	    storeTimestampsSet(oldentry);
+	    storeUpdate(oldentry, http->request);
+	    http->log_type = LOG_TCP_REFRESH_HIT;
+	} else {
+	    http->log_type = LOG_TCP_REFRESH_FAIL_HIT;
 	}
 	storeClientUnregister(http->sc, entry, http);
 	http->sc = http->old_sc;
@@ -1015,11 +909,14 @@
 	/* the client can handle this reply, whatever it is */
 	http->flags.hit = 0;
 	http->log_type = LOG_TCP_REFRESH_MISS;
-	if (HTTP_NOT_MODIFIED == mem->reply->sline.status) {
+	if (HTTP_NOT_MODIFIED == rep->sline.status) {
 	    httpReplyUpdateOnNotModified(http->old_entry->mem_obj->reply,
-		mem->reply);
+		rep);
 	    storeTimestampsSet(http->old_entry);
-	    http->log_type = LOG_TCP_REFRESH_HIT;
+	    if (!EBIT_TEST(http->old_entry->flags, REFRESH_FAILURE))
+		http->log_type = LOG_TCP_REFRESH_HIT;
+	    else
+		http->log_type = LOG_TCP_REFRESH_FAIL_HIT;
 	}
 	/* Get rid of the old entry if not a cache validation */
 	if (!http->request->flags.cache_validation)
@@ -1032,16 +929,11 @@
     http->old_sc = NULL;
     assert(!EBIT_TEST(entry->flags, ENTRY_ABORTED));
     if (recopy) {
-        stmemNodeUnref(&ref);
-	storeClientRef(http->sc, entry,
-	    http->out.offset,
-	    http->out.offset,
-	    SM_PAGE_SIZE,
-	    clientSendMoreHeaderData,
+	storeClientCopyHeaders(http->sc, entry,
+	    clientSendHeaders,
 	    http);
     } else {
-	clientSendMoreHeaderData(data, stmemNodeRef(&ref), size);
-        stmemNodeUnref(&ref);
+	clientSendHeaders(data, rep);
     }
 }
 
@@ -1051,7 +943,7 @@
     squid_off_t object_length;
     MemObject *mem = entry->mem_obj;
     time_t mod_time = entry->lastmod;
-    debug(33, 3) ("modifiedSince: '%s'\n", storeUrl(entry));
+    debug(33, 3) ("modifiedSince: '%s'\n", storeLookupUrl(entry));
     debug(33, 3) ("modifiedSince: mod_time = %ld\n", (long int) mod_time);
     if (mod_time < 0)
 	return 1;
@@ -1116,10 +1008,7 @@
 	    http->entry->mem_obj->method = http->request->method;
 	    http->sc = storeClientRegister(http->entry, http);
 	    http->log_type = LOG_TCP_HIT;
-	    storeClientRef(http->sc, http->entry,
-		http->out.offset,
-		http->out.offset,
-		SM_PAGE_SIZE,
+	    storeClientCopyHeaders(http->sc, http->entry,
 		clientCacheHit,
 		http);
 	    return;
@@ -1407,7 +1296,7 @@
 #endif
 }
 
-static void
+void
 clientInterpretRequestHeaders(clientHttpRequest * http)
 {
     request_t *request = http->request;
@@ -1680,6 +1569,8 @@
 	return 1;
     if (code == LOG_TCP_STALE_HIT)
 	return 1;
+    if (code == LOG_TCP_ASYNC_HIT)
+	return 1;
     if (code == LOG_TCP_IMS_HIT)
 	return 1;
     if (code == LOG_TCP_REFRESH_FAIL_HIT)
@@ -2032,7 +1923,7 @@
     httpHdrMangleList(hdr, request);
 }
 
-/* Used exclusively by clientBuildReply() during failure cases only */
+/* Used exclusively by clientCloneReply() during failure cases only */
 static void
 clientUnwindReply(clientHttpRequest * http, HttpReply * rep)
 {
@@ -2054,7 +1945,7 @@
  * be.
  */
 static HttpReply *
-clientBuildReply(clientHttpRequest * http)
+clientCloneReply(clientHttpRequest * http, HttpReply * orig_rep)
 {
     HttpReply *rep = NULL;
     /* If we don't have a memobj / reply by now then we're stuffed */
@@ -2063,7 +1954,7 @@
 	return NULL;
     }
     /* try to grab the already-parsed header */
-    rep = httpReplyClone(http->sc->entry->mem_obj->reply);
+    rep = httpReplyClone(orig_rep);
     if (rep->pstate == psParsed) {
 	/* enforce 1.0 reply version */
 	httpBuildVersion(&rep->sline.version, 1, 0);
@@ -2108,6 +1999,163 @@
 }
 
 /*
+ * Perform an async refresh of an object
+ */
+typedef struct _clientAsyncRefreshRequest {
+    request_t *request;
+    StoreEntry *entry;
+    StoreEntry *old_entry;
+    store_client *sc;
+    squid_off_t offset;
+    size_t buf_in_use;
+    char readbuf[STORE_CLIENT_BUF_SZ];
+    struct timeval start;
+} clientAsyncRefreshRequest;
+
+CBDATA_TYPE(clientAsyncRefreshRequest);
+
+static void
+clientAsyncDone(clientAsyncRefreshRequest * async)
+{
+    AccessLogEntry al;
+    static aclCheck_t *ch;
+    MemObject *mem = async->entry->mem_obj;
+    request_t *request = async->request;
+    memset(&al, 0, sizeof(al));
+    al.icp.opcode = ICP_INVALID;
+    al.url = mem->url;
+    debug(33, 9) ("clientAsyncDone: url='%s'\n", al.url);
+    al.http.code = mem->reply->sline.status;
+    al.http.content_type = strBuf(mem->reply->content_type);
+    al.cache.size = async->offset;
+    if (async->old_entry->mem_obj)
+	async->old_entry->mem_obj->refresh_timestamp = 0;
+    if (mem->reply->sline.status == 304) {
+	/* Don't memcpy() the whole reply structure here.  For example,
+	 * www.thegist.com (Netscape/1.13) returns a content-length for
+	 * 304's which seems to be the length of the 304 HEADERS!!! and
+	 * not the body they refer to.  */
+	httpReplyUpdateOnNotModified(async->old_entry->mem_obj->reply, async->entry->mem_obj->reply);
+	storeTimestampsSet(async->old_entry);
+	storeUpdate(async->old_entry, async->request);
+	al.cache.code = LOG_TCP_ASYNC_HIT;
+    } else
+	al.cache.code = LOG_TCP_ASYNC_MISS;
+    al.cache.msec = tvSubMsec(async->start, current_time);
+    if (Config.onoff.log_mime_hdrs) {
+	Packer p;
+	MemBuf mb;
+	memBufDefInit(&mb);
+	packerToMemInit(&p, &mb);
+	httpHeaderPackInto(&request->header, &p);
+	al.headers.request = xstrdup(mb.buf);
+	packerClean(&p);
+	memBufClean(&mb);
+    }
+    al.http.method = request->method;
+    al.http.version = request->http_ver;
+    al.hier = request->hier;
+    if (request->auth_user_request) {
+	if (authenticateUserRequestUsername(request->auth_user_request))
+	    al.cache.authuser = xstrdup(authenticateUserRequestUsername(request->auth_user_request));
+	authenticateAuthUserRequestUnlock(request->auth_user_request);
+	request->auth_user_request = NULL;
+    } else if (request->extacl_user) {
+	al.cache.authuser = xstrdup(request->extacl_user);
+    }
+    al.request = request;
+    al.reply = mem->reply;
+    ch = aclChecklistCreate(Config.accessList.http, request, NULL);
+    ch->reply = mem->reply;
+    if (!Config.accessList.log || aclCheckFast(Config.accessList.log, ch))
+	accessLogLog(&al, ch);
+    aclChecklistFree(ch);
+    storeClientUnregister(async->sc, async->entry, async);
+    storeUnlockObject(async->entry);
+    storeUnlockObject(async->old_entry);
+    requestUnlink(async->request);
+    safe_free(al.headers.request);
+    safe_free(al.headers.reply);
+    safe_free(al.cache.authuser);
+    cbdataFree(async);
+}
+
+static void
+clientHandleAsyncReply(void *data, char *buf, ssize_t size)
+{
+    clientAsyncRefreshRequest *async = data;
+    StoreEntry *e = async->entry;
+    if (EBIT_TEST(e->flags, ENTRY_ABORTED)) {
+	clientAsyncDone(async);
+	return;
+    }
+    if (size <= 0) {
+	clientAsyncDone(async);
+	return;
+    }
+    async->offset += size;
+    if (e->mem_obj->reply->sline.status == 304) {
+	clientAsyncDone(async);
+	return;
+    }
+    storeClientCopy(async->sc, async->entry,
+	async->offset,
+	async->offset,
+	STORE_CLIENT_BUF_SZ, async->readbuf,
+	clientHandleAsyncReply,
+	async);
+}
+
+static void
+clientAsyncRefresh(clientHttpRequest * http)
+{
+    char *url = http->uri;
+    clientAsyncRefreshRequest *async;
+    request_t *request = http->request;
+    debug(33, 3) ("clientAsyncRefresh: '%s'\n", http->uri);
+    CBDATA_INIT_TYPE(clientAsyncRefreshRequest);
+    http->entry->mem_obj->refresh_timestamp = squid_curtime;
+    async = cbdataAlloc(clientAsyncRefreshRequest);
+    async->start = current_time;
+    async->request = requestLink(request);
+    async->old_entry = http->entry;
+    storeLockObject(async->old_entry);
+    async->entry = storeCreateEntry(url,
+	request->flags,
+	request->method);
+    async->entry->mem_obj->old_entry = async->old_entry;
+    storeLockObject(async->entry->mem_obj->old_entry);
+    async->sc = storeClientRegister(async->entry, async);
+    request->etags = NULL;	/* Should always be null as this was a cache hit, but just in case.. */
+    httpHeaderDelById(&request->header, HDR_RANGE);
+    httpHeaderDelById(&request->header, HDR_IF_RANGE);
+    httpHeaderDelById(&request->header, HDR_IF_NONE_MATCH);
+    httpHeaderDelById(&request->header, HDR_IF_MATCH);
+    if (async->old_entry->lastmod > 0)
+	request->lastmod = async->old_entry->lastmod;
+    else if (async->old_entry->mem_obj && async->old_entry->mem_obj->reply)
+	request->lastmod = async->old_entry->mem_obj->reply->date;
+    else
+	request->lastmod = -1;
+    if (!request->etag) {
+	const char *etag = httpHeaderGetStr(&async->old_entry->mem_obj->reply->header, HDR_ETAG);
+	if (etag)
+	    async->request->etag = xstrdup(etag);
+    }
+#if DELAY_POOLS
+    /* delay_id is already set on original store client */
+    delaySetStoreClient(async->sc, delayClient(http));
+#endif
+    fwdStart(-1, async->entry, async->request);
+    storeClientCopy(async->sc, async->entry,
+	async->offset,
+	async->offset,
+	STORE_CLIENT_BUF_SZ, async->readbuf,
+	clientHandleAsyncReply,
+	async);
+}
+
+/*
  * clientCacheHit should only be called until the HTTP reply headers
  * have been parsed.  Normally this should be a single call, but
  * it might take more than one.  As soon as we have the headers,
@@ -2115,7 +2163,7 @@
  * clientProcessMiss.
  */
 static void
-clientCacheHit(void *data, mem_node_ref ref, ssize_t size)
+clientCacheHit(void *data, HttpReply * rep)
 {
     clientHttpRequest *http = data;
     StoreEntry *e = http->entry;
@@ -2123,32 +2171,31 @@
     request_t *r = http->request;
     int is_modified = -1;
     int stale;
-    debug(33, 3) ("clientCacheHit: %s, %d bytes\n", http->uri, (int) size);
     http->flags.hit = 0;
     if (http->entry == NULL) {
-        stmemNodeUnref(&ref);
 	debug(33, 3) ("clientCacheHit: request aborted\n");
 	return;
-    } else if (size <= 0) {
+    } else if (!rep) {
 	/* swap in failure */
-        stmemNodeUnref(&ref);
 	debug(33, 3) ("clientCacheHit: swapin failure for %s\n", http->uri);
 	http->log_type = LOG_TCP_SWAPFAIL_MISS;
 	clientProcessMiss(http);
 	return;
     }
-    assert(size > 0);
     mem = e->mem_obj;
+    debug(33, 3) ("clientCacheHit: %s = %d\n", http->uri, rep->sline.status);
     assert(!EBIT_TEST(e->flags, ENTRY_ABORTED));
-    if (!memHaveHeaders(mem)) {
-	debug(33, 1) ("clientCacheHit: No reply headers in '%s'?\n", e->mem_obj->url);
-        stmemNodeUnref(&ref);
+
+    if (r->store_url && mem->store_url == NULL && strcmp(r->store_url, mem->url) != 0) {
+	debug(33, 1) ("clientCacheHit: request has store_url '%s'; mem object in hit doesn't and doesn't match the url '%s'!\n", r->store_url, mem->url);
 	clientProcessMiss(http);
 	return;
-    }
-    if (strcmp(mem->url, urlCanonical(r)) != 0) {
-	debug(33, 1) ("clientCacheHit: URL mismatch '%s' != '%s'?\n", e->mem_obj->url, urlCanonical(r));
-        stmemNodeUnref(&ref);
+    } else if (r->store_url && strcmp(mem->store_url, r->store_url) != 0) {
+	debug(33, 1) ("clientCacheHit: store URL mismatch '%s' != '%s'?\n", mem->store_url, r->store_url);
+	clientProcessMiss(http);
+	return;
+    } else if ((!r->store_url) && (!mem->store_url) && strcmp(mem->url, urlCanonical(r)) != 0) {
+	debug(33, 1) ("clientCacheHit: (store url '%s'); URL mismatch '%s' != '%s'?\n", r->store_url, e->mem_obj->url, urlCanonical(r));
 	clientProcessMiss(http);
 	return;
     }
@@ -2184,7 +2231,6 @@
 	     * so we only get here once. (it also takes care of cancelling loops)
 	     */
 	    debug(33, 2) ("clientProcessHit: Vary detected!\n");
-            stmemNodeUnref(&ref);
 	    return;
 	}
     case VARY_RESTART:
@@ -2194,13 +2240,11 @@
 	safe_free(r->vary_hdr);
 	safe_free(r->vary_headers);
 	clientProcessRequest(http);
-        stmemNodeUnref(&ref);
 	return;
     case VARY_CANCEL:
 	/* varyEvaluateMatch found a object loop. Process as miss */
 	debug(33, 1) ("clientProcessHit: Vary object loop!\n");
 	clientProcessMiss(http);
-        stmemNodeUnref(&ref);
 	return;
     }
     if (r->method == METHOD_PURGE) {
@@ -2209,7 +2253,6 @@
 	http->sc = NULL;
 	storeUnlockObject(e);
 	clientPurgeRequest(http);
-        stmemNodeUnref(&ref);
 	return;
     }
     http->flags.hit = 1;
@@ -2220,11 +2263,9 @@
 #endif
 	    ) {
 	    http->log_type = LOG_TCP_NEGATIVE_HIT;
-	    clientSendMoreHeaderData(data, stmemNodeRef(&ref), size);
-            stmemNodeUnref(&ref);
+	    clientSendHeaders(data, rep);
 	} else {
 	    http->log_type = LOG_TCP_MISS;
-            stmemNodeUnref(&ref);
 	    clientProcessMiss(http);
 	}
 	return;
